#############################################################################
#
#                       Copyright (C) 1994 SciTech Software
#                               All rights reserved.
#
# Descripton:   Generic DMAKE startup makefile definitions file. Assumes
#               that the SCITECH environment variable has been set to point
#               to where all our stuff is installed. You should not need
#               to change anything in this file.
#
#               Symantec C++ 6.1 32 bit version. Supports the DOSX extender
#               and Phar Lap's TNT DOS Extender.
#
# $Id: SC32.MK 1.1 1994/08/22 11:08:20 kjb Exp $
#
#############################################################################

# Disable warnings for macros redefined here that were given
# on the command line.
__.SILENT       := $(.SILENT)
.SILENT         := yes

# File suffix definitions
   L            := .lib   # Libraries
   E            := .exe   # Executables
   O            := .obj   # Objects
   A            := .asm   # Assembler sources
   P            := .cpp   # C++ sources

# Import enivornment variables that we use
TMPDIR := $(ROOTDIR)/tmp
.IMPORT .IGNORE : TMPDIR COMSPEC INCLUDE LIB SCITECH DBG OPT SHW BETA TNTX

# We use the MSDOS shell at all times
   SHELL        := $(COMSPEC)
   GROUPSHELL   := $(SHELL)
   SHELLFLAGS   := $(SWITCHAR)c
   GROUPFLAGS   := $(SHELLFLAGS)
   SHELLMETAS   := *"?<>
   GROUPSUFFIX  := .bat
   DIRSEPSTR    := \\
   DIVFILE       = $(TMPFILE:s,/,\)

# Default commands for compiling, assembling linking and archiving
   CC           := sc       # C-compiler and flags
   CFLAGS       += -4 -Jm
   COMPILE_ONLY := -c       # Only compile the C source, dont link
   AS           := tasm     # Assembler and flags
   ASFLAGS      += /MX /m /D__COMM__ /i$(SCITECH)\INCLUDE
   LD           := sc       # Loader and flags
   LIB          := lib      # Librarian
   LIBFLAGS     += /N /B

# Optionally turn on debugging information
.IF $(DBG)
   CFLAGS       += -g       # Turn on debugging for C compiler
.IF $(TNTX)
   LDFLAGS      += -fullsym # Turn on debugging for TNT 386link linker
.END
.END

# Optionally turn on optimisations
.IF $(OPT)
   CFLAGS       += -o+all
.END

# Optionally turn on direct i387 FPU instructions

.IF $(FPU)
   CFLAGS       += -ff
   ASFLAGS      += -DFPU387
.END

# Optionally compile a shareware version of a product
.IF $(SHW)
   LIB_DIR      := LIBSW
   CFLAGS       += -DSHAREWARE
.ELSE
   LIB_DIR      := LIB
.END

# Optionally compile a beta release version of a product
.IF $(BETA)
   CFLAGS       += -DBETA
   ASFLAGS      += -DBETA
.END

# User a larger stack if requested

.IF $(STKSIZE)
    LDFLAGS     += =$(STKSIZE)
.ENDIF

# Optionally use Phar Lap's TNT DOS Extender, otherwise use DOSX
.IF $(TNTX)
   CFLAGS       += -mp
   DX_CFLAGS    += -DTNT
   ASFLAGS      += /D__FLAT__
   DX_ASFLAGS   += -DTNT
   LD           := 386link
   LDFLAGS      += @sc32.dos -exe $@
.ELSE
   CFLAGS       += -mx
   DX_CFLAGS    += -DDOSX
   ASFLAGS      += /D__X386__
   DX_ASFLAGS   += -DDOSX
   LD           := sc
   LDFLAGS      += $(CFLAGS)
.END

# Define where to install library files
   LIB_DEST     := $(SCITECH)\$(LIB_DIR)\SC32

# Definition of $(MAKE) macro for recursive makes.
   MAKE = $(MAKECMD) $(MFLAGS)

# Macro to install a library file
   INSTALL      := cp

# Implicit generation rules for making object files
   %$O: %.c ; $(CC) $(CFLAGS) -c $<
   %$O: %$P ; $(CC) $(CFLAGS) -c $<
   %$O: %$A ; $(AS) $(ASFLAGS) $(<:s,/,\);

# Implicit rule for building a library file using response file
   %$L: ; $(LIB) $(LIBFLAGS) $@ @$(mktmp -+$(?:t" &\n-+")\n)

# Implicit rule for building an executable file using response file
.IF $(TNTX)
   %$E: ; $(LD) $(LDFLAGS) @$(mktmp,$*.lnk  $& $(EXELIBS))
.ELSE
   %$E: ; $(LD) $(LDFLAGS) -e$@ @$(mktmp,$*.lnk  $& $(EXELIBS))
.ENDIF

# DMAKE uses this recipe to remove intermediate targets
.REMOVE :; $(RM) -f $<

# Turn warnings back to previous setting.
.SILENT := $(__.SILENT)

# We dont use TABS in our makefiles
.NOTABS         := yes

